/** UsaHash.java

 Este software  livre e pode ser redistribudo e/ou modificado
 sob os termos da GNU General Public License, como publicado pela
 Free Software Foundation.

 @author Hemerson Pistori (pistori@ucdb.br)

 Este programa possui propsitos educacionais, e implementa uma
 interface bastante simples para insero em Hash utilizando
 o mtodo da diviso

 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class UsaHash extends JFrame  {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Hash hash;
	JLabel textoEntrada;
	JTextField entrada;
	JButton botaoInsere;
	JButton botaoMudaTamanho;
	JTextArea saida;
//	TreeCanvas treeCanvas;


	/** Inicia a classe UsaHash criando uma hash vazia e apresentando os
	componentes da Interface Grfica */
	public UsaHash() {

		hash = null; 
		criaComponentes();
		setVisible(true); 
	};


	/** Mostra o contedo da pilha na caixa de texto "Saida" */
	private void mostraHash() {
		saida.setText(hash.mostra());
	}


	/** Cria, posiciona e inicia os componentes da Interface
	    grfica, como caixas de textos e botes */
	private void criaComponentes() {

		/** Altera o texto na barra de ttulo da Janela. */
		setTitle("Programa Simples que Utiliza uma Hash");

		/** Cria o texto que ser mostrado acima da caixa de entrada */
		textoEntrada = new JLabel("Tamanho do Vetor ou Elemento a ser Inserido:");

		/** Cria a caixa de entrada para digitao dos elementos 
		    a serem inserido.
		    O tamanho da caixa de texto  de 10 caracteres. */
		entrada = new JTextField(10);

		/** Cria o boto que ao ser clicado, empilha o elemento contido
		 na caixa de texto entrada. */
		botaoInsere = new JButton();
		botaoInsere.setText("Insere");
		botaoInsere.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {

				// Aqui deve ser colocado o cdigo a ser executado quando
				// o usurio clicar no boto.

				if (hash==null) {
					saida.setText("Tamanho do Vetor no foi definido !!!");
				}
				else {
					int chave=Integer.parseInt(entrada.getText());
					boolean colisao=hash.insere(chave);
					if(colisao) mostraColisao(hash.dispersao(chave));
					else mostraHash();
				}}
		});

		/** Cria o boto que ao ser clicado, desempilha um elemento. */
		botaoMudaTamanho = new JButton();
		botaoMudaTamanho.setText("Define Tamanho do Vetor");
		botaoMudaTamanho.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {

				// Aqui deve ser colocado o cdigo a ser executado quando
				// o usurio clicar no boto.
				hash = new Hash(Integer.parseInt(entrada.getText()));
				mostraHash();
			}
		});

		/** Cria caixa de texto para mostrar o contedo da pilha (com 20 linhas e
		   50 colunas */
		saida = new JTextArea(4,50);
		saida.setLineWrap(true);

		/** Determina como os elementos grficos devem ser posicionados
		 na Janela.	 */

		Container principal = getContentPane();
		principal.setLayout(new BoxLayout(principal,BoxLayout.Y_AXIS));
		principal.add(textoEntrada);
		principal.add(entrada);

		/** O Cdigo abaixo  responsvel pelo alinhamento horizontal (X_AXIS) 
		    dos dois botes. Sem esse cdigos, os botes seriam alinhados
			horizontalmente (Y_AXIS) */			
		JPanel botoes = new JPanel();
		botoes.setLayout(new BoxLayout(botoes,BoxLayout.X_AXIS));
		botoes.add(botaoInsere);
		botoes.add(botaoMudaTamanho);

		principal.add(botoes);
		//principal.add(treeCanvas);
		principal.add(saida);


		/** Posicionamento da Janela na Tela do Computador. */
		setLocation(100,40);

		pack();

		/** Fecha o programa quando a janela  fechada. (Sem o cdigo abaixo,
		    a janela fecha mas o programa continua aberto - porm,s inacessvel) */	         addWindowListener(new java.awt.event.WindowAdapter() {
		    	public void windowClosing(java.awt.event.WindowEvent evt) {
		    		System.exit(0);
		    	}
		    });
	}

	protected void mostraColisao(int i) {
		saida.setText("COLISO EM "+i+"\n"+hash.mostra());
	}


	public static void main(String args[]) {
		new UsaHash();
	}


}
